[Setting name="Display a run during validation", category="General"]
bool isEnabled = false;


int windowFlags = UI::WindowFlags::NoResize | UI::WindowFlags::NoCollapse | UI::WindowFlags::AlwaysAutoResize | UI::WindowFlags::NoFocusOnAppearing & UI::WindowFlags::AlwaysUseWindowPadding;


void Setup()
{
#if MP41 && MANIA64
  int32 trueNumber = 1;
  Dev::Write(Dev::BaseAddress() + 0x1D0EA24, trueNumber);
  print("Validation Display is enabled.");
#else
  print("This version of the game is not supported.");
#endif
}

void Stop()
{
#if MP41 && MANIA64
  int32 falseNumber = 0;
  Dev::Write(Dev::BaseAddress() + 0x1D0EA24, falseNumber);
  print("Validation Display is disabled.");
#endif
}

void ApplySetting()
{
  if(isEnabled)
  {
    Setup();
  }
  else
  {
    Stop();
  }
}

bool IsPtrValid(uint64 ptr)
{
  return ptr > 0xFFFFF && ptr <= 0x7FFFFFFFFFFF;
}

#if MANIA64
uint64 FollowPtrChain(array<uint64> ptrChain)
{
  uint64 ptr = 0x0;

  for(int i = 0; i < ptrChain.Length; i++)
  {
    ptr = Dev::ReadUInt64(ptr + ptrChain[i]);
	if(!IsPtrValid(ptr))
	{
	  break;
	}
  }
  
  return ptr;
}
#endif

void RenderMenu()
{
#if MP41 && MANIA64
  if (UI::MenuItem(Icons::Kenney::Movie + " Validation Display", "", isEnabled, true))
  {
    isEnabled = !isEnabled;
	
	ApplySetting();
  }
#endif
}

void RenderInterface()
{
#if MP41 && MANIA64
  uint64 ptr = FollowPtrChain({ Dev::BaseAddress() + 0x1C8B410, 0x390, 0x40, 0x10, 0x10, 0x10 });
  
  if(IsPtrValid(ptr))
  {
    if(UI::Begin("Validation Display", windowFlags))
	{
	  if(UI::Button("Interrupt validation"))
	  {
	    int cancelNumber = -1;
	    Dev::Write(ptr + 0x8, cancelNumber);
	  }
	}
	UI::End();
  }
#endif
}

void OnSettingsChanged()
{
  ApplySetting();
}


void Main()
{
  ApplySetting();
}

void OnDestroyed()
{
  Stop();
}